/*
 *  fuse_osversion.h
 *  fusefs
 *
 *  Created by Erik Larsson on 2012-03-10.
 *  Copyright 2012 Tuxera Inc. All rights reserved.
 *
 */

#ifndef _FUSE_OSVERSION_H_
#define _FUSE_OSVERSION_H_

#ifdef KERNEL
#include <libkern/version.h>
#elif defined(_INFOPLIST_VERSION_MAJOR)
/* Dummy version for the preprocessing stage of 'Info.plist'. */
#define VERSION_MAJOR _INFOPLIST_VERSION_MAJOR
#else
#ifndef __ENVIRONMENT_MAC_OS_X_VERSION_MIN_REQUIRED__
#error "Missing predefined macro __ENVIRONMENT_MAC_OS_X_VERSION_MIN_REQUIRED__. Cannot continue."
#elif __ENVIRONMENT_MAC_OS_X_VERSION_MIN_REQUIRED__ < 1040
#error "Unsupported Mac OS X version (< 10.4)."
#elif __ENVIRONMENT_MAC_OS_X_VERSION_MIN_REQUIRED__ == 1040
#define VERSION_MAJOR 8
#elif __ENVIRONMENT_MAC_OS_X_VERSION_MIN_REQUIRED__ == 1050
#define VERSION_MAJOR 9
#elif __ENVIRONMENT_MAC_OS_X_VERSION_MIN_REQUIRED__ == 1060
#define VERSION_MAJOR 10
#elif __ENVIRONMENT_MAC_OS_X_VERSION_MIN_REQUIRED__ == 1070
#define VERSION_MAJOR 11
#elif __ENVIRONMENT_MAC_OS_X_VERSION_MIN_REQUIRED__ == 1080
#define VERSION_MAJOR 12
#else
#error "Mac OS X version is too new or uneven (in which case you should add a -mmacosx-version-min=10.X flag when compiling)."
#endif
#endif /* defined(KERNEL) */

#endif /* _FUSE_OSVERSION_H_ */
